<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for swighnflew.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
swighnflew - prepare a SUIF file for code generators

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>swighnflew</B> [ <I>options</I> ] <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>swighnflew</I> program does some transformations to the
SUIF file to make it use a lower-level subset of SUIF.
This allows code generators to accept only a simpler subset
of SUIF.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
<B>-branches-compares-only</B><BR>

Make sure that comparison instructions only occur
as operands of branch instructions. Any other comparisons
are turned into conditional branches to
code to set a variable.

<DL>

<DT><B>-no-struct-return</B></DT></DT>
<DD>
Change function calls that return structures into
function calls that return void and are instead
passed the result structure location as the first
argument.
</DD>

<DT><B>-mark-struct-alignment</B></DT></DT>
<DD>
Annotate structure or array copying instructions
and call sites that have structure or array parameters
with the alignment information for the type.
</DD>

<DT><B>-allow-fors</B></DT></DT>
<DD>
Don't complain about for loops. By default, this
code issues an error message if it finds a tree_for
node, because these nodes are expected to be dismantled
before the back-end, for which <I>swighnflew</I>
is intended to prepare the SUIF file.
</DD>

<DT><B>-mark-varargs</B> <I>va</I><B>_</B><I>start</I><B>_</B><I>name</I></DT></DT>
<DD>
Mark all procedures that use an <I>io</I><B>_</B><I>gen</I> instruction
with the name specified by <I>va</I><B>_</B><I>start</I><B>_</B><I>name</I> with a
uses varargs annotation on the proc_sym. The
intention is that <I>va</I><B>_</B><I>start</I><B>_</B><I>name</I> is a built-in function
which is used by the va_start() macro defined
in the target machine's &lt;stdarg.h&gt; and/or
&lt;varargs.h&gt; headers. This allows procedures to be
marked if they use either ANSI-style (&lt;stdarg.h&gt;)
or K&amp;R style (&lt;varargs.h&gt;) variable argument mechanisms.
Some code generators need to know this when
they start processing a procedure body, so it's
convenient to put the annotation on here for such
code generators.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>See</B> <B>Also</B></A></H2>

<P>
<A HREF="man_porky.1.html">porky(1)</A>
, <A HREF="man_oldsuif.1.html">oldsuif(1)</A>
, <A HREF="man_mexp.1.html">mexp(1)</A>
, <A HREF="man_mgen.1.html">mgen(1)</A>


<H2><A NAME="sect5" HREF="#toc5"><B>History</B></A></H2>

<P>
This program was written by Chris Wilson.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">See Also</A></LI>
<LI><A NAME="toc5" HREF="#sect5">History</A></LI>
</UL>
</BODY></HTML>
